"use strict";

var Promise = require("bluebird");

var AbstractInfoWindow = require('./AbstractInfoWindow');
var IdentifiedElement = require('../data/IdentifiedElement');

function PointInfoWindow(params) {
  if (params.identifiedElement === undefined) {
    params.identifiedElement = new IdentifiedElement(params.point);
  }
  // call super constructor
  AbstractInfoWindow.call(this, params);

  this.pointData = params.point;

  var point = this.pointData.getPoint();
  var latLng = this.getCustomMap().fromPointToLatLng(point);
  this.googleInfowindow = new google.maps.InfoWindow({
    content: this.content,
    position: latLng
  });
  this.googleInfowindow.open(this.getCustomMap().getGoogleMap(), this.getGoogleMarker());
  this.update();
}

PointInfoWindow.prototype = Object.create(AbstractInfoWindow.prototype);
PointInfoWindow.prototype.constructor = PointInfoWindow;

PointInfoWindow.prototype.createContentDiv = function () {
  var result = document.createElement("div");
  var title = document.createElement("h3");
  title.innerHTML = "Point: " + this.pointData.getPoint();
  result.appendChild(title);

  return Promise.resolve(result);
};

PointInfoWindow.prototype.getOverlaysData = function (general) {
  return this.getCustomMap().getTopMap().getOverlayDataForPoint(this.pointData, general);
};


module.exports = PointInfoWindow;
